/*
    Display how many days a given month has

    Usage: MonthDay <month/year>
*/

/* check whether the RxDate Function is loaded, if not, load it */
IF RxFuncQuery('RxDate')
    THEN CALL RxFuncAdd 'RxDate', 'RexxDate', 'RxDate'

parse arg myDate
say myDate
if myDate = ''
    then say 'Usage: MonthDay <month/year>'
    else say myDate 'has' MonthDays(myDate) 'days'
return

MonthDays:
	procedure
	parse value arg(1) with month '/' year
	firstOfMonth = RxDate(year'-'month'-1')
	firstOfNextMonth = RxDate(RxDate(firstOfMonth+35, '%Y-%m-1'))
	return firstOfNextMonth-firstOfMonth

